package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.GemLootPoolEntry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraftforge.common.loot.LootModifier;

public class GemLootModifier extends LootModifier {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.loot.GemLootModifier> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.loot.GemLootModifier::new));
  }
  
  protected GemLootModifier(LootItemCondition[] conditionsIn) {
    super(conditionsIn);
  }
  
  protected ObjectArrayList<ItemStack> doApply(ObjectArrayList<ItemStack> generatedLoot, LootContext context) {
    if (!Apotheosis.enableAdventure)
      return generatedLoot; 
    for (AdventureConfig.LootPatternMatcher m : AdventureConfig.GEM_LOOT_RULES) {
      if (m.matches(context.getQueriedLootTableId())) {
        if (context.m_230907_().m_188501_() <= m.chance()) {
          Player player = GemLootPoolEntry.findPlayer(context);
          if (player == null)
            return generatedLoot; 
          float luck = context.m_78945_();
          ItemStack gem = GemRegistry.createRandomGemStack(context.m_230907_(), context.m_78952_(), luck, new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)context.m_78952_()), GameStagesCompat.IStaged.matches(player) });
          generatedLoot.add(gem);
        } 
        break;
      } 
    } 
    return generatedLoot;
  }
  
  public Codec<? extends IGlobalLootModifier> codec() {
    return (Codec)CODEC;
  }
}
